<template>
  <div class="container">
    <h1>Hello</h1>
    <form @submit.prevent="login">
      <div class="form-group">
        <label for="email">Email address</label>
        <input type="email" v-model="email" class="form-control" id="email">
      </div>
      <div class="form-group">
        <label for="password">Password</label>
        <input type="password" v-model="password" class="form-control" id="password">
      </div>
      <button @click="login" class="btn btn-primary">Envoyer</button>
    </form>
  </div>
</template>

<script>

import axios from 'axios'
import { db } from '@/main'

export default {
  name: 'Login',
  data: () => {
    return {
      email: '',
      password: ''
    }
  },
  components: { },
  created () {
    // if user is auth, redirect to home page
    if (this.user.data) {
      this.$router.push('/')
    }
  },
  computed: {
    isFormValid: function () {
      return this.email !== '' && this.password !== ''
    }
  },
  methods: {
    login: function (e) {
      e.preventDefault()
      if (this.isFormValid) {
        db.auth()
          .signInWithEmailAndPassword(this.email, this.password)
          .then((userCredential) => {
            const url = 'https://api.goneslive.fr/users'
            const body = {
              id: userCredential.user.uid,
              email: userCredential.user.email,
              date: {
                createdAt: userCredential.user.metadata.creationTime,
                updateAt: userCredential.user.metadata.lastSignInTime,
                lastSignInTime: userCredential.user.metadata.lastSignInTime
              }
            }
            axios({
              method: 'post',
              url: url,
              data: body
            }).then(r => {
              this.$router.push('/')
            }).catch(e => {
              console.log(e)
            })
            // ...
          })
          .catch((error) => {
            console.error(error)
            // ...
          })
      }
    }
  }
}
</script>
